#ifndef IT_GUI_H
#define IT_GUI_H

#include <gtk/gtkwidget.h>
#include <gtk/gtkuimanager.h>

#include "it_temp.h"
#include "it_core.h"
#include "support/configdb.h"

class IT_GUISettings : public ConfigDB
{
        public:
        IT_GUISettings(ConfigFile *myfile);
        ~IT_GUISettings();
        private:
        static ConfigTemplate Template[];
};


class IT_GUI : public IT_Core
{
	public:
	IT_GUI();
	~IT_GUI();
	void Run();
	void SaveGeometry();

	void Load(const char *filename);
	void GenerateDL();
	void GamutChanged();
	void SrcProfileChanged();
	void PreprocessChanged();
	void OutputChanged();

	void SaveTIFF();
	void SaveJPEG();
	void SaveDevicelink();
	
	void Update();
	void RenderImage(Progress *p=NULL);
	void ProofImage(Progress *p=NULL);
	void RenderDLImage(Temp_Image *srci);
	GtkWidget *window;
	protected:
	CMTransformFactory *factory;

	// UI Elements
	GtkWidget *srcprofselector;
	GtkWidget *destprofselector;
	GtkWidget *srcvc;
	GtkWidget *destvc;
	GtkWidget *preview1;
	GtkWidget *preview2;
	GtkWidget *preview3;
	GtkWidget *generatebutton;
	GtkUIManager *uimanager;
	static void srcps_changed(GtkWidget *widget,gpointer user_data);
	static void destps_changed(GtkWidget *widget,gpointer user_data);
	static void generatedl_clicked(GtkWidget *widget,gpointer user_data);
	static void pbview_changed(GtkWidget *widget,gpointer user_data);
	IT_GUISettings uisettings;

	// Other data
	char *filename;
//	bool dlstale;
	Temp_SrcImage *tmpsrcimage;
	Temp_DeviceLink *devicelink;
	GdkPixbuf *preview_original;
	GdkPixbuf *preview_proof1;
	GdkPixbuf *preview_dltrans;
};

#endif
