#ifndef IT_TEMP_H
#define IT_TEMP_H

#include <stdlib.h>
#include "imagesource/imagesource.h"
#include "support/progress.h"
#include "thread.h"
#include "tempfile.h"

class IT_Core;
class Temp_SrcProfile;
class Temp_Gamut;
class Temp_SrcImage : public TempFile
{
	public:
	Temp_SrcImage(IT_Core *header,const char *srcfn,Progress *p);
	virtual ~Temp_SrcImage();
	Temp_SrcProfile *GetSrcProfile();
	Temp_Gamut *GetGamut();
	void FlushSrcProfile();
	void FlushGamut();
	protected:
	Temp_SrcProfile *srcprofile;
	Temp_Gamut *gamut;
	Progress *progress;
};


class Temp_SrcProfile : public TempFile
{
	public:
	Temp_SrcProfile(IT_Core *header,ImageSource *is);
	virtual ~Temp_SrcProfile();
	protected:
};


class Temp_DestProfile : public TempFile
{
	public:
	Temp_DestProfile(IT_Core *header,const char *profilefn);
	virtual ~Temp_DestProfile();
	protected:
};


class Temp_Gamut : public TempFile
{
	public:
	Temp_Gamut(IT_Core *header,Temp_SrcImage *img,Progress *p);
	~Temp_Gamut();
	protected:
};


class Temp_DeviceLink : public TempFile
{
	public:
	Temp_DeviceLink(IT_Core *header,Temp_SrcImage *img,Progress *p);
	~Temp_DeviceLink();
	protected:
};


class Temp_Image : public TempFile
{
	public:
	Temp_Image(IT_Core *header,const char *infn,Temp_DeviceLink *tdl,Progress *p);
	~Temp_Image();
	protected:
};

#endif
