#include <iostream>
#include <getopt.h>
#include <stdlib.h>

#include <gtk/gtk.h>

#include "support/pathsupport.h"
#include "support/progresstext.h"

#include "it_core.h"
#include "it_gui.h"

#include "config.h"
#include "gettext.h"

using namespace std;


int main(int argc, char **argv)
{
	try
	{
		gtk_init(&argc,&argv);

		gtk_set_locale();
		bindtextdomain(PACKAGE, LOCALEDIR);
		bind_textdomain_codeset(PACKAGE, "UTF-8");
		textdomain(PACKAGE);

		IT_GUI it;
		it.ParseConfigFile();
		it.ParseOptions(argc,argv);
		
		if(optind==argc)
		{
			it.Run();
		}
		else
		{
			ProgressText p;
			for(int i=optind;i<argc;++i)
			{
				it.ProcessFile(argv[i],&p);
			}
		}
	}
	catch(const char *err)
	{
		cerr << "Error: " << err << endl;
	}
	catch(int returncode)
	{
		return(returncode);
	}
	return(0);
}
